import {setOptions} from "./echarts.js";
import * as echarts from 'echarts';
export function setEcharts(ele,option){
    setOptions(ele,option)
}

export function setLeftCharts(ele,percent,color) {
    let  option = {

        title: [ {
            text: percent + "%",
            x: 'center',
            top: '42%',
            textStyle: {
                fontSize: '24',
                color: '#FFFFFF',
                fontFamily: 'DINAlternate-Bold, DINAlternate',
                foontWeight: '600',
            },
        }],
        backgroundColor: 'transparent',
        polar: {
            radius: ['62%', '75%'],
            center: ['50%', '50%'],
        },
        angleAxis: {
            max: 100,
            show: false,
        },
        radiusAxis: {
            type: 'category',
            show: true,
            axisLabel: {
                show: false,
            },
            axisLine: {
                show: false,
            },
            axisTick: {
                show: false,
            },
        },
        series: [{
            name: '',
            type: 'bar',
            roundCap: false,
            barWidth: 90,
            showBackground: true,
            backgroundStyle: {
                color: 'rgba(66, 66, 66, .3)',
            },
            data: [percent],
            coordinateSystem: 'polar',

            itemStyle: {
                normal: {
                    color: color,
                },
            },
        },
            {
                name: '',
                type: 'pie',
                startAngle: 80,
                radius: ['80%'],
                hoverAnimation: false,
                center: ['50%', '50%'],
                itemStyle: {
                    color: 'rgba(66, 66, 66, .1)',
                    borderWidth: 1,
                    borderColor: color,
                },
                data: [100],
            }
        ],

    };
    setOptions(ele,option)
}


export function setRightCharts(ele,dataList) {
    let  option = {
        backgroundColor: 'transparent',
        tooltip: {
            show:false
        },
        grid: {
            left: '8%',
            right: '2%',
            top: '10%',
            bottom: '20%'
        },
        xAxis: [
            {
                type: 'category',
                data: ['在监在建','完工未验','暂停监督','竣工','遗留工地'],
                axisTick: {
                    alignWithLabel: true
                },
                axisLabel: {
                    color: '#FFF',
                    interval: 0,
                    margin: 20,
                    align: 'center'
                }
            }
        ],
        yAxis: {
            splitLine: {
                show: false,
                // lineStyle: {
                //     color:"red"
                // }
            },
            axisTick: {
                show: true,
            },
            axisLine: {
                show: true,
            },
            axisLabel: {
                color: '#FFF'
            }
        },
        series: [
            {
                type: 'bar',
                itemStyle: {
                    normal: {
                        color: (params) => {
                            let colors = ['#619d2c',
                                '#b03b8a',
                                '#c30f07',
                                '#e4e22f',
                                '#09539d']
                            return colors[params.dataIndex]
                        },
                    },
                },
                barWidth: '30',
                data: dataList
               // data: dataList
            }
        ]
    };
    setOptions(ele,option)
}