import axios from "axios";
import {baseUrl, timeout, withCredentials} from "../service/config";
const requestInstance = axios.create({
    baseURL:import.meta.env.VITE_APP_BASE_API,
    timeout,
    method:"post",
})
export function setConfigInstance(config) {
    let instance = axios.create({
        baseURL:baseUrl,
        timeout,
        // method:"post",
        ...config
    })
    return instance
}
requestInstance.interceptors.request.use((config) => {

    let reg = /appkey=.*/
    let isMatch = reg.test(config.url.split('?')[1])
    return {
        ...config,
        url:isMatch?config.url:config.url
    }
},(error) => {
    return new Error(error)
})

requestInstance.interceptors.response.use(function (res) {
    return res.data
},function (error) {
    return new Error(error)
})

export {
    requestInstance
}


const requestInstance_Address = axios.create({
    baseURL:import.meta.env.VITE_APP_ADDRESS_API,
    timeout,
    method:"post"
})
requestInstance_Address.interceptors.request.use((config) => {
    return config
},(error) => {
    return new Error(error)
})

requestInstance_Address.interceptors.response.use(function (res) {
    return res.data
},function (error) {
    return new Error(error)
})

export {
    requestInstance_Address
}
