import {myBridge} from "./map";
import {getServiceToken} from "../../service/service-apply";

const buildingLayerList = ['三维白膜','全市售后公房','保障房白膜']  //地表普通白膜列表
const undergroundBuildingLayerList = [
    '地下构筑物(三维)','地下管点-嘉定','地下管点-奉贤','地下管点-宝山',
    '地下管点-崇明','地下管点-徐汇','地下管点-普陀','地下管点-杨浦',
    '地下管点-松江','地下管点-浦东','地下管点-虹口','地下管点-金山',
    '地下管点-长宁','地下管点-闵行','地下管点-青浦','地下管点-静安',
    '地下管点-黄浦','地下管线-嘉定','地下管线-奉贤','地下管线-宝山',
    '地下管线-崇明','地下管线-徐汇','地下管线-普陀','地下管线-杨浦',
    '地下管线-松江','地下管线-浦东','地下管线-虹口','地下管线-金山',
    '地下管线-长宁','地下管线-闵行','地下管线-青浦','地下管线-静安',
    '地下管线-黄浦', '地铁区间', '高架（地上，梁柱路面）', '高架（地下，承台桩基）'

]  //地下白膜列表

const BIMLayerList = [
    '外环地质',
    '春塔路900弄保障房_2C','春塔路900弄保障房_3C_PC模型','春塔路900弄保障房_3C_幕墙模型','春塔路900弄保障房_3C_建筑模型','春塔路900弄保障房_3C_结构模型',
    '春塔路900弄保障房_1C_幕墙模型','春塔路900弄保障房_1C_建筑模型','春塔路900弄保障房_1C_排水模型','春塔路900弄保障房_1C_暖通模型','春塔路900弄保障房_1C_电模型','春塔路900弄保障房_1C_结构模型',
    '春塔路900弄保障房_4C_幕墙模型','春塔路900弄保障房_4C_建筑模型','春塔路900弄保障房_4C_结构模型','春塔路900弄保障房_5C_幕墙模型','春塔路900弄保障房_5C_建筑模型','春塔路900弄保障房_5C_结构模型',
    '朱家角车站'
]

const underHeight = {   //下沉高度
    mode:"absolute-height",
    offset:-4
}

const overHeight = {   //下沉高度
    mode:"absolute-height",
    offset:2
}
const underStationHeight = {   //下沉高度
    mode:"absolute-height",
    offset:-19.5
}
//获取
function getPipeRenderer() {
    return {
        type: "unique-value",
        field: "TypeName",
        defaultSymbol: getPipeSymbol(""),
        uniqueValueInfos: [{
            value: "电力",
            symbol: getPipeSymbol("电力")
        }, {
            value: "通讯",
            symbol: getPipeSymbol("通讯")
        }, {
            value: "给水",
            symbol: getPipeSymbol("给水")
        }, {
            value: "排水",
            symbol: getPipeSymbol("排水")
        }, {
            value: "燃气",
            symbol: getPipeSymbol("燃气")
        }, {
            value: "热力",
            symbol: getPipeSymbol("热力")
        }, {
            value: "工业",
            symbol: getPipeSymbol("工业")
        }, {
            value: "其它",
            symbol: getPipeSymbol("其它")
        },{
            value: "其它",
            symbol: getPipeSymbol("其它")
        }, {
            value: "长输管线",
            symbol: getPipeSymbol("长输管线")
        }]
    };
}
//获取Symbol
function getPipeSymbol(type) {
    return {
        type: "mesh-3d",
        symbolLayers: [{
            type: "fill",
            material: {
                color: getPipeColor(type)
            },
            edges: {
                type: "solid",
                color: "rgb(0, 0, 0)"
            }
        }]
    };
}

// 测试，管线，符号
function getPipeColor(type) {
    switch (type) {
        case "电力": return "rgb(255, 0, 0)";
        case "通讯": return "rgb(0, 255, 0)";
        case "给水": return "rgb(0, 0, 255)";
        case "排水": return "rgb(153, 0, 0)";
        case "燃气": return "rgb(255, 0, 255)";
        case "热力": return "rgb(255, 102, 0)";
        case "工业": return "rgb(113, 113, 113)";
        case "其它":
        case "长输管线":
        default:
            return "rgb(178, 178, 178)";
    }
}

// 白膜颜色配置
const locationRenderer = {
    type: "simple",
    symbol: {
        type: "mesh-3d",
        symbolLayers: [{
            type: "fill",
            material: {
                color: [255, 255, 255, 0.7],
                colorMixMode: "tint"
            },
            edges: {
                type: 'solid',
                color: [0, 0, 0, 0.8],
                size: 1
            }
        }]
    }
};

// 高架颜色配置
const locationRenderer_GJ = {
    type: "simple",
    symbol: {
        type: "mesh-3d",
        symbolLayers: [{
            type: "fill",
            material: {
                color: [255, 239, 213, 1],
                colorMixMode: "tint"
            },
            edges: {
                type: 'solid',
                color: [255, 239, 213, 1],
                size: 1
            }
        }]
    }
};

// 桩基颜色配置
const locationRenderer_ZJ = {
    type: "simple",
    symbol: {
        type: "mesh-3d",
        symbolLayers: [{
            type: "fill",
            material: {
                color: [255, 239, 213, 1],
                colorMixMode: "tint"
            },
            edges: {
                type: 'solid',
                color: [255, 239, 213, 1],
                size: 1
            }
        }]
    }
};



export function invokeParams(ActionName, params) {
 getServiceToken().then(res => {
     debugger
  let token = res.msg[0].Rows[0].token;
  console.log(ActionName, params)
  myBridge.bridgeContent.Invoke({
   'ActionName': ActionName,
   "Parameters": {
    ...params,
    token: token
   }
  })
 })

}


export function invokePreviewParams(ActionName, params) {
    getServiceToken().then(res => {
        let token = res.msg[0].Rows[0].token;
        console.log(ActionName, params)
        myBridge.previewMapBridge.Invoke({
            'ActionName': ActionName,
            "Parameters": {
                ...params,
                token: token
            }
        })
    })

}


export function AddGDMapLayer(visible,where){
    invokeParams('AddSingleLayer', {
        "id": "gdTheme",
        "title":"gdTheme",
        "visible": visible==undefined?true:visible,
        "opacity": 1,
        "sublayers": [
            {
                "id": 0,
                "definitionExpression":where ==undefined?"1=1":where,
            }
        ],
        //"url": "http://10.81.66.1:8080/site03/rest/services/CONSTRUCTION_TEST_3857/MapServer",
        //"url":"https://10.90.10.154:6443/geoscene/rest/services/construction/MapServer",
        "url":"https://10.90.11.49:2000/MapProxyApi/getSceneServer/fzyjy_sjgl/70207272",
        "type": "dynamic"
    })
}



export function QueryIn2D(where){
    invokeParams('QueryIn2D', {
        "id": "gdTheme",
        "layerId": "0",
        "geometry": null,
        "where": "CODE = '"+where+"'",
        //"where": "CODE = '0902MH0141G002MH'",
        "symbol": {
            "type": "simple-fill",
            "color": "rgba(255,170,150,0.9)",
            "outline": {
                "color": "#FFAA00",
                "width": 2
            }
        },
        "is_draw": true,
        "popup":true
    })
}


export function SetBackground(){
    invokeParams('SetBackground', {
        "visible": true,
        "opacity": 1,
        "theme": "light",
        "color":"#FFF",
    })
}

export function MapClickAll(){
    invokeParams('MapClickAll', {
        "status": "show",
        "popup": "show",
        "disableLayerIdList":[],
    })
}

export function AddSingleLayer(params){
 debugger
  if(params.type=="scene"||params.type=='3DObject'){
    invokeParams('AddSingleLayer', {
      "id": params.id,
      "title": params.title,
      "visible": params.visible,
        "opacity": params.opacity === undefined?1:params.opacity,
      "url": params.url,
      "type": "scene",
      "mapID": params.mapID
    })
  }
  else if(params.type=="bim"){
      switch (params.title) {
          case '朱家角车站':
              invokeParams('AddSingleLayer',
                  {
                      "id": params.id,
                      "title": params.title,
                      "visible": params.visible,
                      "opacity": params.opacity === undefined?1:params.opacity,
                      "url": params.url,
                      "elevationInfo": {   //下沉高度
                          mode:"absolute-height",
                          offset:-19.5
                      },
                      "type": "building",
                      "mapID": params.mapID
                  })
              break;
          default:
              invokeParams('AddSingleLayer',
                  {
                      "id": params.id,
                      "title": params.title,
                      "visible": params.visible,
                      "opacity": params.opacity === undefined?1:params.opacity,
                      "url": params.url,
                      "elevationInfo": {   //下沉高度
                          mode:"absolute-height",
                          offset:-19.5
                      },
                      "type": "building",
                      "mapID": params.mapID
                  })
              break
      }
  }
  else if(params.type=='mesh'){
        invokeParams('AddSingleLayer',
            {
                "id": params.id,
                "title": params.title,
                "visible": params.visible,
                "opacity": params.opacity === undefined?1:params.opacity,
                "url": params.url,
                //"renderer":locationRenderer,
                "type": "mesh",
                "mapID": params.mapID
            })
        return
  }
  else if(params.type=="dynamic"){
    invokeParams('AddSingleLayer', {
      "id": params.id,
      "title": params.title,
      "visible": params.visible,
        "opacity": params.opacity === undefined?1:params.opacity,
      "url": params.url,
      "sublayers": [
        {
          "id": 0
        }
      ],
      "type": "dynamic",
      "mapID": params.mapID
    })
  }
  else if(params.type=="tile"){
    invokeParams('AddSingleLayer', {
      "id": params.id,
      "title": params.title,
      "visible": params.visible,
        "opacity": params.opacity === undefined?1:params.opacity,
      "url": params.url,
      "type": "tile",
      "mapID": params.mapID
    })
  }else if(params.type=="动态地图"){
      if(buildingLayerList.indexOf(params.title) > -1){   //building 3DObject
          invokeParams('AddSingleLayer', {
              "id": params.id,
              "title": params.title,
              "visible": params.visible,
              "opacity": params.opacity === undefined?1:params.opacity,
              "url": params.url,
              "type": "scene",
              "mapID": params.mapID
          })
      }else if(BIMLayerList.indexOf(params.title) > -1){   //BIM
          switch (params.title){
              case '朱家角车站':
                  invokeParams('AddSingleLayer',
                      {
                          "id": params.id,
                          "title": params.title,
                          "visible": params.visible,
                          "opacity": params.opacity === undefined?1:params.opacity,
                          "url": params.url,
                          "elevationInfo": {   //下沉高度
                              mode:"absolute-height",
                              offset:-19.5
                          },
                          "type": "building",
                          "mapID": params.mapID
                      })
                  break;
              default:
                  invokeParams('AddSingleLayer',
                      {
                          "id": params.id,
                          "title": params.title,
                          "visible": params.visible,
                          "opacity": params.opacity === undefined?1:params.opacity,
                          "url": params.url,
                          "type": "building",
                          "mapID": params.mapID
                      })
                  break;
          }
      }else if(undergroundBuildingLayerList.indexOf(params.title) > -1){  //地下构筑物
          switch (params.title){
              case '高架（地上，梁柱路面）':   //地下桩基render设置
                  invokeParams('AddSingleLayer', {
                      "id": params.id,
                      "title": params.title,
                      "visible": params.visible,
                      "opacity": params.opacity === undefined?1:params.opacity,
                      "url": params.url,
                      "elevationInfo":underHeight,
                      "renderer":locationRenderer_GJ,
                      "type": "scene",
                      "mapID": params.mapID
                  })
              break;
              case '高架（地下，承台桩基）':   //地下桩基render设置
                  invokeParams('AddSingleLayer', {
                      "id": params.id,
                      "title": params.title,
                      "visible": params.visible,
                      "opacity": params.opacity === undefined?1:params.opacity,
                      "url": params.url,
                      "elevationInfo":underHeight,
                      "renderer":locationRenderer_ZJ,
                      "type": "scene",
                      "mapID": params.mapID
                  })
               break;
              default:
                  invokeParams('AddSingleLayer', {
                      "id": params.id,
                      "title": params.title,
                      "visible": params.visible,
                      "opacity": params.opacity === undefined?1:params.opacity,
                      "url": params.url,
                      "elevationInfo":underHeight,
                      "renderer":getPipeRenderer(),
                      "type": "scene",
                      "mapID": params.mapID
                  })
                  break;
          }
      }else{
          invokeParams('AddSingleLayer', {
              "id": params.id,
              "title": params.title,
              "visible": params.visible,
              "opacity": params.opacity === undefined?1:params.opacity,
              "url": params.url,
              "type": "shc_map",
              "mapID": params.mapID
          })
      }
  }else if(params.type=="切片地图"){
    let size = [256,256];
    let origin = {
      "x": -9080400.0,
      "y": 10002300
    };
    switch (params.title) {
      case '公众地图':
        invokeParams('AddSingleLayer',
         {
           "id": params.id,
           "title": params.title,
           "visible": params.visible,
             "opacity": params.opacity === undefined?1:params.opacity,
           "url": params.url,
           "type": "shc_tile_old",
           "size": size,
           "chy_token": "m_token",
           "mapID": params.mapID
         })
        break;
      case '晒衣架':
      case '公共绿地':
      case '无障碍设施':
      case '桥孔停车场':
      case '桥孔道班房':
      case '小区绿化':
      case '基础路网(切片)':
        invokeParams('AddSingleLayer',
         {
           "id": params.id,
           "title": params.title,
           "visible": params.visible,
             "opacity": params.opacity === undefined?1:params.opacity,
           "url": params.url,
           "type": "shc_tile",
           "size": size,
           "origin": origin,
           "mapID": params.mapID
         })
        break;
      case '1979航空影像':
      case '2006航空影像':
      case '2015航空影像':
      case '1994航空影像':
      case '1948航空影像':
      case '政务地图':
      case '政务地图_简易地形':
       console.log('dsdds',params)
        invokeParams('AddSingleLayer',
         {
           "id": params.id,
           "title": params.title,
           "visible": params.visible,
           "opacity": params.opacity === undefined?1:params.opacity,
           "url": params.url,
           "type": "shc_tile",
           "chy_token": "m_token"
         })
        break;
      default:
        invokeParams('AddSingleLayer',
         {
           "id": params.id,
           "title": params.title,
           "visible": params.visible,
           "opacity": params.opacity === undefined?1:params.opacity,
           "url": params.url,
           "type": "shc_tile",
           "mapID": params.mapID
         })
        break;
    }
  }
}



export function AddPreviewSingleLayer(params){


    if(params.type=="scene"){
        invokePreviewParams('AddSingleLayer', {
            "id": params.id,
            "title": params.title,
            "visible": params.visible,
            "opacity": 1,
            "url": params.url,
            "type": "scene",
            "mapID": params.mapID
        })
    }
    else if(params.type=="dynamic"){
        invokePreviewParams('AddSingleLayer', {
            "id": params.id,
            "title": params.title,
            "visible": params.visible,
            "opacity": 1,
            "url": params.url,
            "sublayers": [
                {
                    "id": 0
                }
            ],
            "type": "dynamic",
            "mapID": params.mapID
        })
    }
    else if(params.type=="tile"){
        invokePreviewParams('AddSingleLayer', {
            "id": params.id,
            "title": params.title,
            "visible": params.visible,
            "opacity": 1,
            "url": params.url,
            "type": "tile",
            "mapID": params.mapID
        })
    }else if(params.type=="动态地图"){
        invokePreviewParams('AddSingleLayer', {
            "id": params.id,
            "title": params.title,
            "visible": params.visible,
            "opacity": params.opacity === undefined?1:params.opacity,
            "url": params.url,
            "type": "shc_map",
            "mapID": params.mapID
        })
    }else if(params.type=="切片地图"){
        let size = [256,256];
        let origin = {
            "x": -9080400.0,
            "y": 10002300
        };
        switch (params.title) {
            case '公众地图':
                invokePreviewParams('AddSingleLayer',
                    {
                        "id": params.id,
                        "title": params.title,
                        "visible": params.visible,
                        "opacity": 1,
                        "url": params.url,
                        "type": "shc_tile_old",
                        "size": size,
                        "chy_token": "m_token",
                        "mapID": params.mapID
                    })
                break;
            case '晒衣架':
            case '公共绿地':
            case '无障碍设施':
            case '桥孔停车场':
            case '桥孔道班房':
            case '小区绿化':
            case '基础路网(切片)':
                invokePreviewParams('AddSingleLayer',
                    {
                        "id": params.id,
                        "title": params.title,
                        "visible": params.visible,
                        "opacity": 1,
                        "url": params.url,
                        "type": "shc_tile",
                        "size": size,
                        "origin": origin,
                        "mapID": params.mapID
                    })
                break;
            case '1979航空影像':
            case '2006航空影像':
            case '2015航空影像':
            case '1994航空影像':
            case '1948航空影像':
            case '政务地图':
            case '政务地图_简易地形':
                console.log('dsdds',params)
                invokePreviewParams('AddSingleLayer',
                    {
                        "id": params.id,
                        "title": params.title,
                        "visible": params.visible,
                        "opacity": params.opacity === undefined?1:params.opacity,
                        "url": params.url,
                        "type": "shc_tile",
                        "chy_token": "m_token"
                    })
                break;
            default:
                invokePreviewParams('AddSingleLayer',
                    {
                        "id": params.id,
                        "title": params.title,
                        "visible": params.visible,
                        "opacity": params.opacity === undefined?1:params.opacity,
                        "url": params.url,
                        "type": "shc_tile",
                        "mapID": params.mapID
                    })
                break;
        }
    }
}





export function setLocation(params){
 invokeParams('SetLocation', {
  "heading": params.heading == undefined?0:params.heading,
  "tilt": params.tilt == undefined?0:params.tilt,
  "x": params.x,
  "y": params.y,
  "z":  params.z == undefined?100:params.z,
  "isfly": true,
 })
}
export function drawGraphic(positionGeometry){
 invokeParams('DrawGraphic', {
  "type":"point",
  "geometry":positionGeometry,
  "symbol": {
   "type": "picture-marker",
   "url": "http://localhost:8080/jk_map_tool_source/hj/marker.png",
   "width": "20px",
   "height": "20px",
   "yoffset": 10,
   "xoffset": 0
  },
  "clear": true,
 })
}

export function positionToAddress(x,y){
 let positionGeometry =
  {
   "type": "point",
   "x": x,
   "y": y,
   "z": 0
  };
 drawGraphic(positionGeometry);
 setLocation({
  "x": parseFloat(x),
  "y": parseFloat(y)
 });
}
export function clearAllLayerMap() {
 invokeParams("ClearMapLayers",{
  "mapID": "map"
 })
}
